/// <reference types="node" />
import type { RouteData } from '../../@types/astro';
import type { SSRManifest } from './types';
import { IncomingMessage } from 'node:http';
import { App, type MatchOptions } from './index.js';
declare class NodeIncomingMessage extends IncomingMessage {
    /**
     * The read-only body property of the Request interface contains a ReadableStream with the body contents that have been added to the request.
     */
    body?: unknown;
}
export declare class NodeApp extends App {
    match(req: NodeIncomingMessage | Request, opts?: MatchOptions): RouteData | undefined;
    render(req: NodeIncomingMessage | Request, routeData?: RouteData, locals?: object): Promise<Response>;
}
export declare function loadManifest(rootFolder: URL): Promise<SSRManifest>;
export declare function loadApp(rootFolder: URL): Promise<NodeApp>;
export {};
