/// <reference types="node" />
/// <reference types="node" />
import type http from 'node:http';
import type { AddressInfo } from 'node:net';
import type * as vite from 'vite';
import type { AstroInlineConfig } from '../../@types/astro';
export interface DevServer {
    address: AddressInfo;
    handle: (req: http.IncomingMessage, res: http.ServerResponse<http.IncomingMessage>) => void;
    watcher: vite.FSWatcher;
    stop(): Promise<void>;
}
/** `astro dev` */
export default function dev(inlineConfig: AstroInlineConfig): Promise<DevServer>;
