import type { AstroCookies, ComponentInstance, MiddlewareHandler, RouteType } from '../../@types/astro';
import { type EndpointCallResult } from '../endpoint/index.js';
import type { RenderContext } from './context.js';
import type { Environment } from './environment.js';
export type RenderPage = {
    mod: ComponentInstance;
    renderContext: RenderContext;
    env: Environment;
    cookies: AstroCookies;
};
/**
 * It attempts to render a route. A route can be a:
 * - page
 * - redirect
 * - endpoint
 *
 * ## Errors
 *
 * It throws an error if the page can't be rendered.
 */
export declare function tryRenderRoute<MiddlewareReturnType = Response>(routeType: RouteType, renderContext: Readonly<RenderContext>, env: Readonly<Environment>, mod: Readonly<ComponentInstance>, onRequest?: MiddlewareHandler<MiddlewareReturnType>): Promise<Response | EndpointCallResult>;
export declare function isEndpointResult(result: any, routeType: RouteType): result is EndpointCallResult;
export declare function isResponse(result: any, routeType: RouteType): result is Response;
